#!/bin/bash
#
# Parse the .csv file for loading into a PostgreSQL database
#
FILE=pd-2008-01-28-occs.csv
#
# 1. Start with the second record since the first is field titles
# 2. Turn all double double quotes into ~ (since ~ does not occur in the file)
# 3. Search for commas within double quoted fields and replace with + (since +
#    does not occur in the file)
#    (Note: this method has the side effect of adding a double quote at the
#     end of every record, but we're getting rid of those pesky double quotes
#     in the next step anyway.)
# 4. Blow away all double quotes
# 5. Replace all comma delimiters with the new vertical bar delimiter (don't
#    worry, vertical bar is not already used in the file)
# 6. Turn plus signs back into commas
# 7. Turn tildes back into double quotes
# 8. Escape single quotes so they can be easily added to the database
tail -n+2 ${FILE} | sed 's/""/~/g' | awk -F'"' '{for (i = 1; i <= NF; i++) { if (i%2) { printf "%s\"", $i; } else { string = $i; gsub(",", "+", string); printf "%s\"", string; } } printf "\n";}' | sed 's/"//g' | sed 's/,/|/g' | sed 's/+/,/g' | sed 's/~/"/g' | sed 's/'"'/\\\'"'/g'
