close all;clc;clear
tic
rand('state',3)
load query_4.csv
t=query_4(:,1);
y=query_4(:,2);
y0=query_4(:,2);
for i=1:length(y)-1
    step(i)=y(i+1)-y(i);
end
%% Detrend
[P Sy]=polyfit(t,y,3);
Y0 = polyval(P,t);
y=y-Y0;
SDy=std(y);    %% all time series are normalized to have variance = 1
y=y/SDy;
%% Do not need to interpolate
LL=2^(16);
Y = fft(y,LL);
Pyy = Y.* conj(Y)/(LL);
%% frequency = 1/period
f=[0:1:round(0.05*LL)]/LL;

numtest=40
chknum=numtest/10
for itest = 1:numtest
    if chknum*fix(itest/chknum)==itest
        itest
    end
%% Permute
    yc(1,1) = y(1,1);
    RP=randperm(541);
    for istep = 1:541
        yc(istep+1,1) = yc(istep,1) + step(RP(istep));
    end
%% Detrend
    [P S]=polyfit(t,yc,3);
    Yc = polyval(P,t);
    z=yc-Yc;
    SDz=std(z);
    z=z/SDz;  %%Normalize to have variance = 1
    Y = fft(z,LL);
    Pzz = Y.* conj(Y)/(LL);
    for isa=1:round(0.05*LL)+1
        Qsave(itest,isa)=Pzz(isa);
    end
end
for isa=1:round(0.05*LL)+1
    ave(isa)=mean(Qsave(:,isa));
    sd(isa)=std(Qsave(:,isa));
end
plot(f(1:round(0.05*LL)+1),ave,'1')
hold
%plot(f(1:round(0.05*LL)+1),sd,'8')
fid=fopen('dft_marine_output_f_step.dat','w');
for k = 1:round(0.05*LL)+1
    fprintf(fid,'%f %f\n',f(k),ave(k));
end
fclose(fid);

% RANDOM BLOCK TRIAL
numtest=40
chknum=numtest/10
for itest = 1:numtest
    if chknum*fix(itest/chknum)==itest
        itest
    end
%% Permute
    RP=randperm(20);
    is=0;
    for ib=1:20
        if RP(ib)==20
             for j = 1:29
                 is = is+1;
                 yc(is,1)=y0((RP(ib)-1)*27+j);
             end
        else
             for j = 1:27
                 is = is+1;
                 yc(is,1)=y0((RP(ib)-1)*27+j);
             end
        end
    end
%% Detrend
    [P S]=polyfit(t,yc,3);
    Yc = polyval(P,t);
    z=yc-Yc;
    SDz=std(z);
    z=z/SDz; %%Normalize to have variance = 1
    Y = fft(z,LL);
    Pzz = Y.* conj(Y)/(LL);
    for isa=1:round(0.05*LL)+1
        Qsave(itest,isa)=Pzz(isa);
%%        Qsave(itest,isa)=Pzz(isa)/norm(z);
    end
end
for isa=1:round(0.05*LL)+1
    ave(isa)=mean(Qsave(:,isa));
    sd(isa)=std(Qsave(:,isa));
end
plot(f(1:round(0.05*LL)+1),ave,'3')
%plot(f(1:round(0.05*LL)+1),sd,'5')
fid=fopen('dft_marine_output_f_marine_blk.dat','w');
for k = 1:round(0.05*LL)+1
    fprintf(fid,'%f %f %f\n',f(k),Pyy(k),ave(k));
end
fclose(fid);
toc
plot(f,Pyy(1:round(0.05*LL)+1),'k')

ylabel('Spectral Power')
xlabel('Frequency (cycles/Myr)')
title('G30782_mins_maxs NEARSHORE FT (single occurrence excluded)')
axis([.0001 0.05 0 1])
print  -depsc dft.eps
